/*  
 * Aggiunta di costruttori e della funzione Print() alla classe Point.
 * I costruttori servono ad inizializzare i membri di un oggetto.
 * compilare: 
 * -> g++ -o main2 main2.cpp 
 * eseguire:
 * -> ./main2
 */

#include <cmath>
#include <iostream>
#include <string>

using namespace std;

/* dichiarazione classe Point */
class Point {
public:
  Point();
  Point(string name);
  Point(string name, double x, double y);

  void SetX(double x) { fX = x; }
  void SetY(double y) { fY = y; }
  double GetX() { return fX; }
  double GetY() { return fY; }
  double Magnitude();
  void Print();

private:
  double fX;
  double fY;
  string fName;

};

Point::Point() 
{
  fX = 0;
  fY = 0;
  fName = "Unknown";
}

Point::Point(string name) 
{
  fX = 0;
  fY = 0;
  fName = name;
}

Point::Point(string name, double x, double y)
{
  fName = name;
  fX = x;
  fY = y;
}

double Point::Magnitude()
{
    return sqrt(fX*fX+fY*fY); 
}

void Point::Print() 
{
  cout<<fName<<": fX = "<<fX<<" fY = "<<fY<<endl;
}


/* funzione main() */
int main() {
    Point A("PuntoA"),B("PuntoB");
    Point C("PuntoC",19,13.2),D;
    A.Print(); 
    A.SetX(3.2);
    A.SetY(1.2);
    A.Print();
    B.SetX(5.2);
    B.SetY(7.3);
    B.Print();
    C.Print();
    D.Print();

    double magA = A.Magnitude();
    double magB = B.Magnitude();

    cout<<"MagA "<<magA<<endl;
    cout<<"MagB "<<magB<<endl;

    return 0;
}
