/*  
 *  Aggiunta della classe Line, che ha due oggetti della classe Point come
 *  membri.
 * compilare: 
 * -> g++ -o main3 main3.cpp 
 * eseguire:
 * -> ./main3
 */

#include <cmath>
#include <iostream>
#include <string>

using namespace std;

/* dichiarazione classe Point */
class Point {
public:
  Point();
  Point(string name);
  Point(string name, double x, double y);

  void SetX(double x) { fX = x; }
  void SetY(double y) { fY = y; }
  double GetX() { return fX; }
  double GetY() { return fY; }
  double Magnitude();
  void Print();

private:
  double fX;
  double fY;
  string fName;

};

/* implementazione classe Point */
Point::Point() 
{
  fX = 0;
  fY = 0;
  fName = "Unknown";
}

Point::Point(string name) 
{
  fX = 0;
  fY = 0;
  fName = name;
}

Point::Point(string name, double x, double y)
{
  fName = name;
  fX = x;
  fY = y;
}

double Point::Magnitude()
{
    return sqrt(fX*fX+fY*fY); 
}

void Point::Print() 
{
  cout<<fName<<": fX = "<<fX<<" fY = "<<fY<<endl;
}


/* dichiarazione classe Line */
class Line {
public:
    Line(string name, Point a, Point b) 
    {
        fName = name;
        fA = a;
        fB = b;
    }

    void Print();

    double Magnitude();
  
private:
  string fName;
  Point fA;
  Point fB;

};

double Line::Magnitude()
{
    double mag;
    mag = sqrt(pow(fA.GetX()-fB.GetX(),2)+pow(fA.GetY()-fB.GetY(),2));
    return mag;
}

void Line::Print()
{
  cout<<fName<<": "<<endl;
  fA.Print();
  fB.Print();
  cout<<"*****"<<endl;
}



/* funzione main() */
int main() {
    Point A("PuntoA"),B("PuntoB");
    Point C("PuntoC",19,13.2),D;
    A.Print(); 
    A.SetX(3.2);
    A.SetY(1.2);
    A.Print();
    B.SetX(5.2);
    B.SetY(7.3);
    B.Print();
    C.Print();
    D.Print();

    // chiama la funzione Magnitude definita in Point
    double magA = A.Magnitude();
    double magB = B.Magnitude();

    cout<<"MagA "<<magA<<endl;
    cout<<"MagB "<<magB<<endl;

    Line L("LineaL",A,C);
    L.Print();
    // chiama la funzione Magnitude definita in Line
    cout<<"Lunghezzea linea L: "<<L.Magnitude()<<endl;
    return 0;
}
